<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
    "http://www.w3.org/TR/REC-html40/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="author" content="Behdad Esfahbod">
<meta name="copyright" content="Sharif FarsiWeb, Inc.">
<meta name="keywords"
content="Bidirectional,Bidi,Layout,GTK+,Pango,Persian,Arabic,Hebrew,GNOME,KDE,freedesktop.org,FarsiWeb,Behdad,Esfahbod,Unicode,DDC,Desktop
Developers Conference">
<meta name="description" content="My talk at DDC'04 about Bidirectional
Layouts in GTK+">
<title>Bidirectional Layouts in GTK+</title>
<link rel="StyleSheet" type="text/css" href="bidi-layouts.css">
</head>
<body>
<a name="top">&nbsp;</a>
<?php

$title = "Bidirectional Layouts in GTK+, DDC'2004";

function slide_start() {
  global $body, $slide;
  $body = 0;
  $slide++;
  ?><br/><a name="<?php echo $slide; ?>"></a><div class="slide"><?php
}
function slide_end() {
  global $body, $slide, $title;
  if($body) echo '</div>';
  echo "</div><br/><div class=\"footer\">".
    "<table width=\"95%\"><tr><td>&nbsp;</td><td align=center>$title</td><td align=right><a href=\"#$slide\">$slide</a></td></tr></table></div><br/><br/>";
}
function slide_title($title='', $cont=0, $center=0) {
  global $body;
  $body = 1;
  if ($title)
    echo "<h1>$title".($cont?'<span style="font-size: 30%">&nbsp;continued</span>':'')."</h1>\n";
  echo '<div class="slidebody"'.($center?' style="text-align: center;"':'').'>';
}

function example_start() { ?><table cellpadding=0 cellspacing=0><tr><?php }
function example_end() { ?></tr></table><?php }
function example_seg($rtl,$text) {
  ?><td><table cellpadding=0 cellspacing=0><tr><td>
    <table cellpadding=0 cellspacing=0 width="100%"><tr>
    <?php if (!$rtl) { ?>
    <td width=1><img alt=">" src="arrow-tail-left.png"/></td><td
      width="*"><img alt="-" width="100%" height="20px" src="arrow-body.png"
      /></td><td width=1><img alt=">" height="20px" src="arrow-right.png"/></td>
    <?php } else { ?>
    <td width=1><img alt="<" height="20px" src="arrow-left.png"
      /></td><td width="*"><img alt="-" width="100%" height="20px"
      src="arrow-body.png"/></td><td width=1><img alt="<" src="arrow-tail-right.png"/></td>
    <?php } ?>
    </tr></table></td></tr><tr><td><code><?php
    echo str_replace(" ", "&nbsp;", $text);
  ?></code></td></tr></table></td><?php
}

?>


<?php slide_start(); ?>
<br/>
<h1 style="text-align: center;">Bidirectional Layouts in GTK+</h1>
<br/>
<h2 style="text-align: center; color: white;">Behdad Esfahbod
<br/><code>behdad behdad org</code>
<br/>Sharif FarsiWeb, Inc.
<br/><a
href="http://www.farsiweb.info/"><code>http://www.farsiweb.info/</code></a>
</h2>
<br/>
<h3 style="text-align: center; color: white;"><img
  src="ddc_logo.png" alt="Desktop Developers' Conference"/>
  <br/>Ottawa, 19 July 2004</h3>
<br/>
<a href="http://validator.w3.org/check?uri=referer"><img border="0"
  src="http://www.w3.org/Icons/valid-html40"
  alt="Valid HTML 4.0!" height="31" width="88"></a>
<a href="http://jigsaw.w3.org/css-validator/">
  <img style="border:0;width:88px;height:31px"
  src="http://jigsaw.w3.org/css-validator/images/vcss" 
  alt="Valid CSS!"></a>
<br/>
Slides at
<code><a href="http://behdad.org/download/Presentations/bidi-layouts/">http://behdad.org/download/Presentations/bidi-layouts/</a></code>
<br/>
Sources at
<code><a href="http://behdad.org/download/Presentations/bidi-layouts.tar.gz">http://behdad.org/download/Presentations/bidi-layouts/bidi-layouts.tar.gz</a></code>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Overview'); ?>
<ul>
<li>Bidirectional Scripts</li>
<li>Unicode Bidirectional Algorithm</li>
<li>Bidirectional Text Layout</li>
<li>Bidirectional Widget Layout</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Bidirectional Scripts'); ?>
<ul>
  <li>Scripts: Hebrew, Arabic, Syriac, Thaana</li>
  <li>Languages: Hebrew, Yiddish, Judezmo,
    Arabic, Persian, Urdu, Pashto, Sindhi, Kurdish,
    Syriac,
    Dhivehi, ...</li>
  <li>Mainly written from Right to Left (compared to Latin and others being
      written from Left to Right)</li>
  <li>With numbers written from Left to Right</li>
  <li>→ Bidirectional</li>
  <li>More Bidirectional when mixed with Left-to-Right scripts (eg. Latin)</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Unicode Bidirectional Algorithm', 0, 1); ?>
Unicode Standard Annex #9<br/>
<a href="http://www.unicode.org/reports/tr9/"><code>http://www.unicode.org/reports/tr9/</code></a>
<p>
    <table width="100%" align=center><tr>
    <td>Phase 1:<br/>
    <div class="algorithm">
    Input:
    <ul>
      <li>Optional paragraph direction</li>
      <li><em>One</em> paragraph of text</li>
    </ul>
    Output:
    <ul>
      <li><em>Resolved</em> paragraph direction</li>
      <li><em>Resolved embedding levels</em></li>
    </ul>
    </div>
    </td><td>&nbsp;</td><td>
    Phase 2:<br/>
    <div class="algorithm">
    Input:
    <ul>
      <li> <em>One</em> line of text</li>
      <li>Resolved embedding levels</li>
    </ul>
    Output:
    <ul>
      <li>Visual order of characters in the line</li>
    </ul>
    </div>
    </td>
    </tr></table>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('', 0, 1); ?>
Example:<br/>CAPITAL letters denote Right-to-Left characters
<p>
    <table align=center width="100%"><tr>
    <td>Phase 1:<br/>
    <div class="algorithm">
    Input:
    <ul>
      <li>Paragraph:<br/>
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new car IN HEBREW."); ?>
        <?php example_end(); ?>
    </ul>
    Output:
    <ul>
      <li>Resolved paragraph direction:<br/>
        RTL (Right-to-Left)</li>
      <li>Resolved embedding levels:<br/>
        <?php example_start(); ?>
	<?php example_seg(1, "11111111111"); ?>
	<?php example_seg(0, "2222222"); ?>
	<?php example_seg(1, "11111111111"); ?>
        <?php example_end(); ?>
    </ul>
    </div>
    Line break:<br/>
    <div class="algorithm">
      Lines of text:<br/>
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "car IN HEBREW."); ?>
        <?php example_end(); ?>
    </div>
    </td><td>&nbsp;</td><td>
    Phase 2:<br/>
    <div class="algorithm">
    Input:
    <ul>
      <li>Lines of text:<br/>
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "car IN HEBREW."); ?>
        <?php example_end(); ?>
      <li>Resolved embedding levels:<br/>
        <?php example_start(); ?>
	<?php example_seg(1, "11111111111"); ?>
	<?php example_seg(0, "222"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "222"); ?>
	<?php example_seg(1, "11111111111"); ?>
        <?php example_end(); ?>
    </ul>
    Output:
    <ul>
      <li>Visual order:<br/>
        <div align=right>
        <?php example_start(); ?>
	<?php example_seg(0, "new"); ?>
	<?php example_seg(1, " SI RAC WEN"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(1, ".WERBEH NI "); ?>
	<?php example_seg(0, "car"); ?>
        <?php example_end(); ?>
	</div>
	</li>
    </ul>
    </div>
    </td>
    </tr></table>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('', 0, 1); ?>
<span class="wrong">Wrong:</span>
If we do both phases on <strong>lines</strong>:
    <table align=center width="100%"><tr>
    <td>
    Line break:<br/>
    <div class="algorithm">
      Lines of text:<br/>
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "car IN HEBREW."); ?>
        <?php example_end(); ?>
    </div>
    Phase 1:<br/>
    <div class="algorithm">
    Input:
    <ul>
        <li>Paragraphs:
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "car IN HEBREW."); ?>
        <?php example_end(); ?>
    </ul>
    Output:
    <ul>
      <li>Resolved paragraph direction: RTL, LTR</li>
      <li>Resolved embedding levels:<br/>
        <?php example_start(); ?>
	<?php example_seg(1, "11111111111"); ?>
	<?php example_seg(0, "222"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "0000"); ?>
	<?php example_seg(1, "111111111"); ?>
	<?php example_seg(0, "0"); ?>
        <?php example_end(); ?>
    </ul>
    </div>
    </td><td>&nbsp;</td><td>
    Phase 2:<br/>
    <div class="algorithm">
    Input:
    <ul>
      <li>Lines of text:<br/>
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "car IN HEBREW."); ?>
        <?php example_end(); ?>
      <li>Resolved embedding levels:<br/>
        <?php example_start(); ?>
	<?php example_seg(1, "11111111111"); ?>
	<?php example_seg(0, "222"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "0000"); ?>
	<?php example_seg(1, "111111111"); ?>
	<?php example_seg(0, "0"); ?>
        <?php example_end(); ?>
    </ul>
    Output:
    <ul>
      <li>Visual order:<br/>
        <div align=right>
        <?php example_start(); ?>
	<?php example_seg(0, "new"); ?>
	<?php example_seg(1, " SI RAC WEN"); ?>
        <?php example_end(); ?>
	</div>
        <?php example_start(); ?>
	<?php example_seg(0, "car "); ?>
	<?php example_seg(1, "WERBEH NI"); ?>
	<?php example_seg(0, "."); ?>
        <?php example_end(); ?>
	</li>
    </ul>
    </div>
    </td>
    </tr></table>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('', 0, 1); ?>
<span class="wrong">Wrong:</span>
If we do both phases on <strong>paragraphs</strong>:
    <table align=center width="100%"><tr>
    <td>Phase 1:<br/>
    <div class="algorithm">
    Input:
    <ul>
      <li>Paragraph:<br/>
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new car IN HEBREW."); ?>
        <?php example_end(); ?>
    </ul>
    Output:
    <ul>
      <li>Resolved paragraph direction:<br/>
        RTL (Right-to-Left)</li>
      <li>Resolved embedding levels:<br/>
        <?php example_start(); ?>
	<?php example_seg(1, "11111111111"); ?>
	<?php example_seg(0, "2222222"); ?>
	<?php example_seg(1, "11111111111"); ?>
        <?php example_end(); ?>
    </ul>
    </div>
    </td><td>&nbsp;</td><td>
    Phase 2:<br/>
    <div class="algorithm">
    Input:
    <ul>
      <li>Line of text:<br/>
        <?php example_start(); ?>
	<?php example_seg(0, "NEW CAR IS new car IN HEBREW."); ?>
        <?php example_end(); ?>
      <li>Resolved embedding levels:<br/>
        <?php example_start(); ?>
	<?php example_seg(1, "11111111111"); ?>
	<?php example_seg(0, "2222222"); ?>
	<?php example_seg(1, "11111111111"); ?>
        <?php example_end(); ?>
    </ul>
    Output:
    <ul>
      <li>Visual order:<br/>
        <div align=right>
        <?php example_start(); ?>
	<?php example_seg(1, ".WERBEH NI "); ?>
	<?php example_seg(0, "new car"); ?>
	<?php example_seg(1, " SI RAC WEN"); ?>
        <?php example_end(); ?>
	</div>
	</li>
    </ul>
    </div>
    Line break:<br/>
    <div class="algorithm">
      Lines of text:<br/>
        <div align=right>
        <?php example_start(); ?>
	<?php example_seg(1, ".WERBEH NI "); ?>
	<?php example_seg(0, "new"); ?>
        <?php example_end(); ?>
        <?php example_start(); ?>
	<?php example_seg(0, "car"); ?>
	<?php example_seg(1, " SI RAC WEN"); ?>
        <?php example_end(); ?>
	</div>
    </div>
    </td>
    </tr></table>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Bidirectional Text Layout'); ?>
Unicode Bidi Algorithm leaves it to higher level protocols to:
<ul>
<li>Override paragraph direction if needed</li>
<li>Provide direction for <em>neutral</em> paragraphs
(eg. a paragraph of “...”)</li>
</ul>
What we expect from this higher level protocol is:
<ul>
<li>Soundness: If all <em>strong</em> paragraphs are of the same direction, we expect it
to assign that same direction to all neutral paragraphs</li>
<li>Locality: Editing some paragraph here in the text should not
affect another paragraph far from here</li>
<li>Robustness: Behave the same under different conditions as much as
possible</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Paragraph Direction Propagation Algorithm'); ?>
<div class="algorithm">
For each paragraph:
<ul>
<li>If not neutral, resolve to paragraph direction</li>
<li>Otherwise, if previous paragraph has a resolved direction, resolve to that
direction</li>
<li>Otherwise, if next paragraph has a resolved direction, resolve to that
direction</li>
<li>Otherwise, resolve to <em>document direction</em>
</ul>
</div>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Paragraph Direction Propagation Algorithm', 1); ?>
Pros:
<ul>
<li>Does the Right Thing</li>
<li>Perfect for LTR-only/RTL-only text</li>
<li>Works locally</li>
<li>Inherits from previous paragraph is possible</li>
<li>Unless absolutely necessary, does not rely on the document direction</li>
</ul>
Implementations:
<ul>
<li>GTK+ 2.4 (GNOME Bug <a
    href="http://bugzilla.gnome.org/show_bug.cgi?id=70451">#70451</a>)</li>
<li>Qt does something along the same lines</li>
<li>No other system bothers to try (yet)</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Paragraph Direction Propagation Algorithm', 1); ?>
Cons:
<ul>
<li>Word-Processing applications like to leave it to user to set direction for
individual paragraphs</li>
<li>Not easy to override direction for an individual paragraph</li>
<li>Breaks applications like The GIMP that provide buttons to set paragraph
direction</li>
<li>Looks forward, which is not quite possible when dealing with <em>streams</em></li>
</ul>
Solutions:
<ul>
<li>Fix the applications!</li>
<li>Ask user to use Unicode markup characters LRM/RLM
to override a paragraph's direction</li>
<li>An streaming version can be used, by removing the look-forward rule in the
algorithm</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title(''); ?>
Big problem:
GTK+ already implements this, but several applications that do not work
with plain text need to implement it again, eg. GAIM, AbiWord, ...
    <table align=center><tr>
    <td><span class="wrong">Bad</span> (Current):<br/>
      <img alt="An screen-shot of GAIM, showing some of current problems" src="gaim-bad.png"/>
    </td>
    <td>&nbsp;&nbsp;</td>
    <td><span class="right">Good</span> (Ideal):<br/>
      <img alt="Another screen-shot of GAIM, showing the ideal layout" src="gaim-good.png"/>
    </td>
    </tr></table>
Solution:
<ul>
<li>Export the functionality to applications so they break their Pango layout
into multiple layouts and propagate direction using exported API? Not really
easy</li>
<li>Add Pango markup to <em>ignore</em> parts of the text when determining
paragraph directions?</li>
</ul
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Sources of Document Direction'); ?>
<ul>
<li>Resolved Widget Direction
  <ul>
  <li>Robust</li>
  <li>My favorite, unless a better solution is found</li>
  </ul>
</li>
<li>Keyboard-Layout Direction
  <ul>
  <li>Not available all the time</li>
  <li>Currently is used in GTK+ to <em>override</em> the last item when
  available</li>
  <li>Feels better if you are entering text in <em>the other</em> direction</li>
  <li>Neutral paragraph will <em>jump</em> to the other side when you leave
  the field...
    <ul>
    <li>...unless you put markup to remember the direction...
      <ul>
      <li>...which makes it quite complicated</li>
      <li>and hard to predict</li>
      </ul>
    </li>
    </ul>
  </li>
  </ul>
</li>
<li>GNOME Bugs
  <a href="http://bugzilla.gnome.org/show_bug.cgi?id=116626">#116626</a>
  and
  <a href="http://bugzilla.gnome.org/show_bug.cgi?id=136529">#136529</a>
</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Direction, Alignment, Justification'); ?>
<?php $s = 'نمی‌دانم. ولی به نظر تنها کاری می‌رسید که در هفته‌ی اولِ
ژانویه‌ی ۱۹۶۴ می‌شد انجام داد، و دو نفر را هم پیدا کردم که
همراهی‌ام کنند. یکی از آن‌ها خواسته که نامش فاش نشود، که عیبی
ندارد...'; ?>
<p align=center>
<span class="right">Right</span> direction (RTL)
<table align=center width="100%">
<tr>
<td><div class="example persian correct" style="direction: rtl; text-align: right;">
<?php echo $s; ?></div></td>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><div class="example persian correct" style="direction: rtl; text-align: justify;">
<?php echo $s; ?></div></td>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><div class="example persian correct" style="direction: rtl; text-align: left;">
<?php echo $s; ?></div></td>
</tr>
<tr><td>&nbsp;</td></tr>
<tr>
<td><div class="example persian incorrect" style="direction: ltr; text-align: right;">
<?php echo $s; ?></div></td>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><div class="example persian incorrect" style="direction: ltr; text-align: justify;">
<?php echo $s; ?></div></td>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><div class="example persian incorrect" style="direction: ltr; text-align: left;">
<?php echo $s; ?></div></td>
</table>
<span class="wrong">Wrong</span> direction (LTR)
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Bidirectional Widget Layout'); ?>
<p align=center>
Classic from Pango Gallery
<br/>
<img alt="Screen-shot from old GTK+ color-selection dialog under fa_IR locale" src="fa-colors.png"/>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Bidirectional Widget Layouts<br/>in GTK+ Today'); ?>
<ul>
<li>Translator decides that a locale is Right-to-Left
<br/>...good way, but eventually the Glibc locale should provide this
information</li>
<li>All in a sudden, Left and Right are swapped!</li>
<li>Did you have this in mind?</li>
<li>Widget directions default to Right-to-Left</li>
<li>Horizontal packing is done from Right to Left</li>
<li>X Align is done from Right to Left</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Examples - gedit'); ?>
<p align=center>
gedit under en_US (English) locale:
<img alt="An annotated screen-shot of gedit, under en_US locale" src="gedit-en_US.png"/>
<p align=center>
gedit under fa_IR (Persian) locale:
<img alt="Another annotated screen-shot of gedit, under fa_IR locale" src="gedit-fa_IR.png"/>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Examples - AbiWord'); ?>
<p align=center>
AbiWord under en_US (English) locale:
<img alt="An annotated screen-shot of AbiWord, under en_US locale" src="AbiWord-en_US.png"/>
<p align=center>
AbiWord under fa_IR (Persian) locale:
<img alt="Another annotated screen-shot of AbiWord, under fa_IR locale" src="AbiWord-fa_IR.png"/>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('GtkJustification'); ?>
<pre class="code">
<span style="color: blue;">/* justification for label and maybe other widgets (text?) */</span>
<span style="color: green;">typedef enum</span>
{
  GTK_JUSTIFY_LEFT,
  GTK_JUSTIFY_RIGHT,
  GTK_JUSTIFY_CENTER,
  GTK_JUSTIFY_FILL
} GtkJustification;

<span style="color: green;">void</span>             gtk_label_set_justify (GtkLabel         *label,
                                        GtkJustification jtype);
<span style="color: green;">GtkJustification</span> gtk_label_get_justify (GtkLabel         *label);
</pre>
<p align=center>
(GTK_JUSTIFY_FILL is just a place-holder right now)
<br/><br/>
<table align=center><tr>
<td>LEFT<br/><img alt="A label with GtkJustification set to LEFT" src="GtkJustification-left.png"/></td>
<td>RIGHT<br/><img alt="A label with GtkJustification set to RIGHT" src="GtkJustification-right.png"/></td>
<td>CENTER<br/><img alt="A label with GtkJustification set to CENTER" src="GtkJustification-center.png"/></td>
<td>FILL<br/><img alt="A label with GtkJustification set to FILL" src="GtkJustification-fill.png"/></td>
</tr></table>
<p align=center>
<span class="wrong">Wrong!</span>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('GtkJustification - Better?'); ?>
<ul>
<li>Should change direction under Right-to-Left locale? (widget direction)</li>
<li>Should change direction under Right-to-Left paragraph? (paragraph direction)</li>
<li>Do you mean the other side?</li>
</ul>
<p align=center>
<span style="font-size: 300%;">2<sup>3</sup>=8</span>
<span style="font-size: 200%;">different alignment functions</span>
</p>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('8!'); ?>
<table align=center>
<?php
  $width = 150;
  for ($other = 0; $other < 2; $other++) {
    echo "<tr>\n";
    for ($widdir = 0; $widdir < 2; $widdir++) {
      for ($pardir = 0; $pardir < 2; $pardir++) {
	echo "<td class=\"algorithm\" align=center>\n";
        for ($thelang = 0; $thelang < 2; $thelang++) {
	  $lang = $thelang ? "fa_IR" : "en_US";
	  echo $lang.'<br/><table class="example" width='.$width.'>';
          for ($thepardir = 0; $thepardir < 2; $thepardir++) {
	    $dir = $other ^ ($widdir & $thelang) ^ ($pardir & $thepardir);
	    $text = $thepardir ? "من" : "Am";
	    echo "<tr><td align=".($dir?"right":"left").">$text</td></tr>\n";
	  }
	  echo '</table>';
	}
	echo "</td><td>&nbsp;&nbsp;&nbsp;</td>\n";
      }
    }
    echo "</tr><tr><td>&nbsp;</td></tr>\n";
  }
?>
</table>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Do We Need them All?'); ?>
Seems so
<p>
<table style="border:1px solid;" align=center>
<tr><td align=right width=160><b>User:</b><td><input size=10 value=behdad>
<tr><td align=right><b>Password:</b><td><input type=password size=10 value=123>
<tr><td align=right><b>Language:</b><td>
<select>
  <option>English
</select>
</table>
&nbsp;
&nbsp;
&nbsp;
&nbsp;
&nbsp;
<table style="direction:rtl; border:1px solid;" align=center>
<tr><td align=left width=160><b>کاربر:</b><td><input size=10 value="بهداد">
<tr><td align=left><b>گذرواژه:</b><td><input size=10 type=password value=123>
<tr><td align=left><b>زبان:</b><td>
<select>
  <option>فارسی
</select>
</table>
<?php slide_end(); ?>

<?php slide_start(); ?>
<?php slide_title('So?'); ?>
<ul>
<li>Sounds good, we have two of these, add the other six: New values,
  backward compatible!</li>
</ul>
<p align=center>
<span style="font-size: 200%;">But Wait!</span>
<ul>
<li>Add up to 10 counting for Center and Fill too, can you name them?</li>
<li>Current GTK_JUSTIFY_LEFT and GTK_JUSTIFY_RIGHT are wrong
  <ul>
  <li>Fix the code?</li>
  <li>Then applications break :-(</li>
  <li>What a Western developer means by LEFT, most probably is: LEFT
    for Latin and RIGHT for Arabic, which is the current behavior
  </ul>
</li>
</ul>
Solution?
<ul>
<li>Define bit masks for new alignments in GtkJustification,
deprecate old values and keep for compatibility</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('GtkTextDirection'); ?>
<pre class="code">
<span style="color: blue;">/* Reading directions for text */</span>
<span style="color: green;">typedef enum</span>
{
  GTK_TEXT_DIR_NONE,
  GTK_TEXT_DIR_LTR,
  GTK_TEXT_DIR_RTL
} GtkTextDirection;

<span style="color: blue;">/* Functions for setting directionality for widgets*/</span>
<span style="color: green;">void</span>             gtk_widget_set_direction         (GtkWidget        *widget,
                                                   GtkTextDirection  dir);
<span style="color: green;">GtkTextDirection</span> gtk_widget_get_direction         (GtkWidget        *widget);
<span style="color: green;">void</span>             gtk_widget_set_default_direction (GtkTextDirection  dir);
<span style="color: green;">GtkTextDirection</span> gtk_widget_get_default_direction (void);
</pre>

<ul>
<li>Unlike what comment and names suggest, this is used for all packing and
other widget directions too (comments in source explain that)</li>
<li>The default direction is initialized by the locale direction</li>
<li>Since our paragraph direction propagation algorithm hardly relies on the
widget direction, user should not need too much control over this! Good</li>
<li>GTK_TEXT_DIR_NONE means default direction, what about
reverse of the default direction? Add value to enum for completeness?</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('A Hierarchical Model?'); ?>
How about inheriting direction from parent?
<ul>
<li>HTML/CSS model does this</li>
<li>Allows RTL and LTR layouts simultaneously</li>
</ul>
But:
<ul>
<li>Current locale model in Glibc does not allow two locales simultaneously
anyway</li>
<li>Current model in GTK+ does not allow that</li>
<li>Childs are binded to parents after initialization</li>
<li>Is complicated and hard to predict</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('What Else?'); ?>
<ul>
<li>It's just the beginning</li>
<li>All those LEFTs and RIGHTs in gtkenums.h are scary</li>
<li>A framework for icon translation? Sure? What about themes then?</li>
<li>Lots of work needs to be done in individual applications...</li>
<li>...not a big problem, those who care about Bidirectional layouts go and
fix them</li>
<li>Didn't covered in this talk: Cursor movement and mouse selection</li>
</ul>
Solution:
<ul>
<li>Start a working group on freedesktop.org and document these all</li>
<li>Write HOWTOs for different toolboxes on how to design bidi-friendly
layouts</li>
<li>Work with GNOME Usability people to update the HIG if necessary, and add
needed checks to their checklists</li>
</ul>
<?php slide_end(); ?>


<?php slide_start(); ?>
<?php slide_title('Questions?'); ?>
<p align=center style="font-size: 300%; margin-top: 3em;">
~FIN~
<?php slide_end(); ?>


</body>
</html>
